//+------------------------------------------------------------------+
//|                                                MA_In_Color.mq4   |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//| Modified from LSMA_In_Color to use any MA by Robert Hill         |     
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+


#property  copyright "Copyright  2006, FX Sniper and Robert Hill"
#property  link      "http://www.metaquotes.net/"

//---- indicator settings

#property  indicator_chart_window
#property  indicator_buffers 3
#property indicator_color1 Yellow      
#property indicator_color2 Lime
#property indicator_color3 Red

extern bool   Show.Gauge  = true ;
extern int myChartX   = 10 ;
extern int myChartY   = 150 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;


extern bool   Show.PriceBox  = true ;

extern int       MAPeriod         = 5;
extern string    notetype         = "0=SMA,1=EMA,2=SMMA,3=LWMA" ;
extern int       MAType           = 1;
extern string    noteprice        = "0=CLOSE,1=OPEN,2=HIGH,3=LOW,4=MEDIAN,5=PP,6=WEIGHT" ;
extern int       MAPrice          = PRICE_CLOSE ;
extern int       myLineWidth = 3;
extern int       myBoxWidth  = 3;
//---- buffers


extern color colorHead = Orange ;
extern color colorTop  =  Chocolate ;
extern color colorMid  =  Chocolate ;
extern color colorBot  =  Chocolate ;
extern color colorUp   = Aqua ;
extern color colorEq   = Yellow ;
extern color colorDn   = Magenta ;


double Buffer[];
double BufferUp[];
double BufferDn[];
/*

PARM6 FOR MA = 

PRICE_CLOSE	0	Close price.
PRICE_OPEN	1	Open price.
PRICE_HIGH	2	High price.
PRICE_LOW	3	Low price.
PRICE_MEDIAN	4	Median price, (high+low)/2.
PRICE_TYPICAL	5	Typical price, (high+low+close)/3.
PRICE_WEIGHTED	6	Weighted close price, (high+low+close+close)/4.


PARM3 FOR MA = 
MODE_SMA	0	Simple moving average,
MODE_EMA	1	Exponential moving average,
MODE_SMMA	2	Smoothed moving average,
MODE_LWMA	3	Linear weighted moving average.

*/
//---- variables

int    MAMode;
string strMAType;

string tShortName ;

color ColorMA ;


   double MA_Cur, MA_Prev;

int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;   
 
string symbol, tChartPeriod, shortName, ShortName ;  

int    digits2, digits, period, win ; 

string lbl[15], lbl2[15];

int n, j ;
 

string ObjG001,ObjG002,ObjG003,ObjG004,ObjG005,ObjG006,ObjG007,ObjG008,ObjG009;  

double close, diff, value, point, range, xPct ;
color pColor = Blue ; 

//+------------------------------------------------------------------+
int init()
  {
  
   period = Period() ;  
      
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;

   win          =  0 ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
  
  
   IndicatorBuffers(3);
   
//---- drawing settings


   SetIndexBuffer(0,Buffer);
   SetIndexBuffer(1,BufferUp);   
   SetIndexBuffer(2,BufferDn);

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,myLineWidth,colorEq);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,myLineWidth,colorUp);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,myLineWidth,colorDn);   
   
switch (MAType)
   {
      case 1: strMAType="EMA"; MAMode=MODE_EMA; break;
      case 2: strMAType="SMMA"; MAMode=MODE_SMMA; break;
      case 3: strMAType="LWMA"; MAMode=MODE_LWMA; break;
      case 4: strMAType="LSMA"; break;
      default: strMAType="SMA"; MAMode=MODE_SMA; break;
   }
   tShortName = "maic"+strMAType+ " (" +MAPeriod + ") "+ MAPrice ;
   IndicatorShortName(tShortName);
   
   
      ShortName    =  tShortName ;
   
//---- initialization done


   deinit() ;
   
if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 10 ; //  
   x003 = 60 ;  // val  
   x004 = 0 ; //  dif
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;  
   FillAmt = 23 ; 
}


   return(0);
  }

//+------------------------------------------------------------------+
double LSMA(int Rperiod, int shift)
{
   int i;
   double sum;
   int length;
   double lengthvar;
   double tmp;
   double wt;

   length = Rperiod;
 
   sum = 0;
   for(i = length; i >= 1  ; i--)
   {
     lengthvar = length + 1;
     lengthvar /= 3;
     tmp = 0;
     tmp = ( i - lengthvar)*Close[length-i+shift];
     sum+=tmp;
    }
    wt = sum*6/(length*(length+1));
    
    return(wt);
}



//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+

int deinit()
{
    
   ObDeleteObjectsByPrefix("ma");          
   TRO() ;                      
return(0);
}

//+------------------------------------------------------------------+
int start()

  {
  
   int limit;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;

   for(int i=limit; i>=0; i--)
   {
      if (MAType == 4)
      {
        MA_Cur = LSMA(MAPeriod,i);
        MA_Prev = LSMA(MAPeriod,i+1);
      }
      else
      {
        MA_Cur = iMA(NULL,0,MAPeriod,0,MAMode,MAPrice,i);
        MA_Prev = iMA(NULL,0,MAPeriod,0,MAMode,MAPrice,i+1);
      }
 
         
//========== COLOR CODING ===========================================               
        
       BufferDn[i] = EMPTY_VALUE; 
       BufferUp[i] = EMPTY_VALUE;  
       Buffer[i]   = MA_Cur;  
       
        if (MA_Prev > MA_Cur)
        {
        BufferDn[i] = MA_Cur;
        ColorMA = colorDn ;
        }
       else if (MA_Prev < MA_Cur) 
        {
        BufferUp[i] = MA_Cur;  
        ColorMA = colorUp ;
        }
         else 
         {
         ColorMA = colorEq ;
         }
        
      }
    MessageBox(DoubleToStr(Buffer[0], Digits));
    MessageBox(DoubleToStr(BufferUp[0], Digits));

   if(Show.PriceBox) 
   {    
    if (ObjectFind(tShortName) != 0)
      {
          ObjectCreate(tShortName,OBJ_ARROW,0,Time[0],MA_Cur);
          ObjectSet(tShortName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName,OBJPROP_COLOR,ColorMA);  
          ObjectSet(tShortName,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName,0,Time[0],MA_Cur);
         ObjectSet(tShortName,OBJPROP_COLOR,ColorMA);  
      }
   } 
    
  
   if(Show.Gauge)  DoShowGauge();
   
   WindowRedraw() ;
    
return(0);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+

void DoShowGauge()
{
n       = 10;
j       = 0 ;

close   = iClose(symbol,period,0) ;

lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + " " + strMAType+ " (" +MAPeriod + ") "+ MAPrice  , FillAmt) ;
DoShow(j, colorHead);
 

j       = j + 1;
lbl[j]  = ShortName+j;
value   = MA_Cur ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Mov Avg "  , FillAmt) ;
DoShow(j, pColor);


}


//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

if(u > 0)
{
string Obj001 = lbl[u] + "val" ;
string sVal = fFill(DoubleToStr(value,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "dif" ;
string sDif =  rtadjust( DoubleToStr(diff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,dsColor);
}

n = n+20;

return(0);

}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = colorUp ; } else {
if(c1 < c2 ) { pColor = colorDn ; } else { pColor = colorEq ; } } 

}  
   
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
 

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+--------- TRO MODIFICATION ---------------------------------------+   

