//+------------------------------------------------------------------+
//|                                                Master_Candle.mq4 |
//|                                                         Zen_Leow |
//|                                                                  |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "Zen_Leow"
#property link      ""

#property indicator_chart_window

extern bool   Show.Boxes   = true ;
extern bool   Show.Labels  = true ;

extern int MinEngulfCandles  = 2;
extern color TopLineColor    = Red ;
extern color BottomLineColor = Blue ;
extern int LineWidth         = 1;
extern int     iShiftLabel   = 0;

int   ShiftLabel;
//+------------------------------------------------------------------+
int init()
{
   

   TRO();
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
{
//----
   int    obj_total=ObjectsTotal();
   string name, topLine, bottomLine;
   topLine = Symbol()+"_"+Period()+"_MasterTop_";
   bottomLine = Symbol()+"_"+Period()+"_MasterBottom_";
   for(int i=obj_total-1; i>=0; i--)
   {
      name=ObjectName(i);
      if (StringFind(name,topLine,0) != -1 || StringFind(name,bottomLine,0) != -1)
      {
         ObjectDelete(name);
      }
   }
//----
   return(0);
}

//+------------------------------------------------------------------+
int start()
{
   int i;                           // Bar index       
   int Counted_bars;                // Number of counted bars
   //--------------------------------------------------------------------   
   Counted_bars=IndicatorCounted(); // Number of counted bars   
//   i=Bars-Counted_bars-1;           // Index of the first uncounted   
   
   
   i = WindowBarsPerChart() ; 
   if(iShiftLabel == 0) {ShiftLabel = (i / 25) * 4 ; } else ShiftLabel = iShiftLabel ;
   
   
   // always recount the latest possible location for a master candle to be formed
   if (i == 0)
   {
      i = MinEngulfCandles+1; 
   }
   while(i>MinEngulfCandles)                      // Loop for uncounted bars     
   {      
      if (isMasterCandle(i))
      {
         DrawLines(i);
      }
      i--;
   }
//----
   return(0);
}

bool isMasterCandle(int index)
{
   double CandleTop = High[index];
   double CandleBottom = Low[index];
   
   for (int h = index-1; h >= index - MinEngulfCandles; h--)
   {
      if (High[h] > CandleTop || Low[h] < CandleBottom)
      {
         return (false);
      }
   }
   
   return (true);
}

//+------------------------------------------------------------------+
void DrawLines(int index)
{
   string TopName = Symbol()+"_"+Period()+"_MasterTop_" + Time[index];
   ObjectCreate(TopName, OBJ_TREND, 0, Time[index], High[index], Time[0], High[index]);
   ObjectSet(TopName, OBJPROP_RAY, false);
   ObjectSet(TopName, OBJPROP_WIDTH, LineWidth);
   ObjectSet(TopName, OBJPROP_COLOR, TopLineColor);

   if(Show.Boxes)
   {  
     string dName = TopName+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],High[index]);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,TopLineColor);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],High[index]);
      } 
   } // if 

      
   if(Show.Labels)
   {         

      datetime LabelTime = Time[0]+Period()*60*ShiftLabel ;
      
      string Obj0002 = TopName+"linelbl" ;
      
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, High[index]);
         ObjectSetText(Obj0002,"High["+ index +"]" , 8, "Arial", TopLineColor);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, High[index]);
      } // if 
                 
   } // if 

   
   string BottomName = Symbol()+"_"+Period()+"_MasterBottom_" + Time[index];
   ObjectCreate(BottomName, OBJ_TREND, 0, Time[index], Low[index], Time[0], Low[index]);
   ObjectSet(BottomName, OBJPROP_RAY, false);
   ObjectSet(BottomName, OBJPROP_WIDTH, LineWidth);
   ObjectSet(BottomName, OBJPROP_COLOR, BottomLineColor);
   
   if(Show.Boxes)
   {  
     dName = BottomName+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],Low[index]);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,BottomLineColor);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],Low[index]);
      } 
   } // if    

   if(Show.Labels)
   {         

      LabelTime = Time[0]+Period()*60*ShiftLabel ;
      
      Obj0002 = BottomName+"linelbl" ;
      
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, Low[index]);
         ObjectSetText(Obj0002,"Low["+ index +"]" , 8, "Arial", BottomLineColor);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, Low[index]);
      } // if 
                 
   } // if 
   
}

//+------------------------------------------------------------------+  
void TRO()
{   

   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
  
//+------------------------------------------------------------------+
//   if(AccountNumber() == 1135362) {return(0);} 